--SYS:
创建远程credential
begin
  dbms_scheduler.create_credential(
        credential_name => 'credential2',
        username => 'oracle',
        password => 'oracle');
end;

grant execute  on credential2 to hr; 
select  * from dba_scheduler_external_dests;
--查到STATION41
begin
   dbms_scheduler.create_file_watcher(
   file_watcher_name => 'filewatcher2',
   directory_path => '/home/oracle/yourfile',
   file_name =>  'botang*.txt',
   credential_name => 'credential2',
   destination => 'STATION41');
end;

begin
 DBMS_SCHEDULER.enable('filewatcher2');
end;

--em界面做也可以
By default, file watchers only check for the arrival of files every 10 minutes, but this default interval can be changed by issuing the following statement.

BEGIN
  DBMS_SCHEDULER.set_attribute(
    'file_watcher_schedule',
    'repeat_interval',
    'freq=minutely; interval=1');
END;
/
    
select  * from dba_scheduler_file_watchers; 
grant execute on filewatcher2 to hr;

--HR:   
create table hr.tfilewatcher2( a  varchar2(200)  ) ;  

create or replace procedure hr.procfilewatcher2( p_1  SYS.SCHEDULER_FILEWATCHER_RESULT)
is
begin
  insert into  hr.tfilewatcher2 values ( to_char( p_1.file_timestamp,'YYYY-MM-DD:HH24:MI:SS') ||'      '
                                                      ||p_1.directory_path||'        '
                                                      ||p_1.actual_file_name||'       '
                                                      ||p_1.file_size  ) ;
  commit;
end;
  
begin
    dbms_scheduler.create_program(
     program_name => 'HR.program12',
     program_type => 'STORED_PROCEDURE',
     program_action => 'HR.procfilewatcher2',
     number_of_arguments => 1,
     enabled => false);
end; 

begin
   dbms_scheduler.define_metadata_argument(
   program_name => 'HR.program12',
   metadata_attribute => 'event_message',argument_position => 1 ) ;
end;

begin
  dbms_scheduler.enable('HR.program12');
end;

BEGIN
  DBMS_SCHEDULER.CREATE_JOB(
   jOB_NAME=> 'hr.job12',
   PROGRAM_NAME=> 'hr.program12',
   EVENT_CONDITION => 'tab.user_data.file_size > 10',
   QUEUE_SPEC=> 'filewatcher2',
   AUTO_DROP=> FALSE,
   ENABLED=> true);
END;

begin
   dbms_scheduler.set_attribute('hr.job12','parallel_instances',true);
end;

select  * from  hr.tfilewatcher2; 
